#**************************************************************
# Time Information
#**************************************************************
set_time_format -unit ns -decimal_places 3
#**************************************************************
# Create Clock
#**************************************************************
create_clock -name {CLK27M} -period  27MHz [get_ports {CLK27M}]
create_clock -name {CLK33M} -period  33MHz [get_ports {CLK33M}]
create_clock -name {CLK50M} -period  50MHz [get_ports {CLK50M}]
create_clock -name {CLK125M} -period 125MHz [get_ports {CLK125M}]
create_clock -name {SMA_CLKIN} -period 24MHz [get_ports {SMA_CLKIN}]
create_clock -name {TSE_MAC_CLK} -period 125MHz [get_ports {TSE_MAC_CLK}]
create_clock -name {TSE_RX_CLK} -period 125MHz -waveform {2 6} [get_ports {TSE_RX_CLK}]
create_clock -name {EZ_CLK} -period 48MHz [get_ports {EZ_CLK}]
create_clock -name {HSMC_1_CLKIN} -period 100MHz [get_ports {HSMC_1_CLKIN}]
create_clock -name {HSMC_2_CLKIN} -period 100MHz [get_ports {HSMC_2_CLKIN}]
create_clock -name {HSMC_3_CLKIN} -period 100MHz [get_ports {HSMC_3_CLKIN}]
create_clock -name {VIRTUAL_TSE_RCK} -period 125MHz
derive_pll_clocks
#**************************************************************
# Create Generated Clock
#**************************************************************
#**************************************************************
# Set Clock Latency
#**************************************************************
#**************************************************************
# Set Clock Uncertainty
#**************************************************************
derive_clock_uncertainty
#**************************************************************
# Set Input Delay
#**************************************************************
#**************************************************************
# Set Output Delay
#**************************************************************
#**************************************************************
# Set Clock Groups
#**************************************************************
set_clock_groups -asynchronous \
-group {CLK27M} \
-group {CLK33M} \
-group {cpu_top|mem_if_ddr3_emif_0|pll0|pll_afi_clk \
        cpu_top|mem_if_ddr3_emif_0|pll0|pll_avl_clk \
        cpu_top|mem_if_ddr3_emif_0|pll0|pll_avl_phy_clk \
        cpu_top|mem_if_ddr3_emif_0|pll0|pll_config_clk \
        cpu_top|mem_if_ddr3_emif_0|pll0|pll_dq_write_clk \
        cpu_top|mem_if_ddr3_emif_0|pll0|pll_write_clk } \
-group {CLK50M}\
-group {pll|pll_inst|altera_pll_i|general[0].gpll~PLL_OUTPUT_COUNTER|divclk} \
-group {CLK125M} \
-group {SMA_CLKIN} \
-group {TSE_MAC_CLK} \
-group {TSE_RX_CLK} \
-group {EZ_CLK} \
-group {HSMC_1_CLKIN} \
-group {HSMC_2_CLKIN} \
-group {HSMC_3_CLKIN} \

#**************************************************************
# Set False Path
#**************************************************************
#**************************************************************
# Set Multicycle Path
#**************************************************************
#**************************************************************
# Set Maximum Delay
#**************************************************************
#**************************************************************
# Set Minimum Delay
#**************************************************************
#**************************************************************
# Set Input Transition
#**************************************************************


