// (C) 2001-2013 Altera Corporation. All rights reserved.
// Your use of Altera Corporation's design tools, logic functions and other 
// software and tools, and its AMPP partner logic functions, and any output 
// files any of the foregoing (including device programming or simulation 
// files), and any associated documentation or information are expressly subject 
// to the terms and conditions of the Altera Program License Subscription 
// Agreement, Altera MegaCore Function License Agreement, or other applicable 
// license agreement, including, without limitation, that your use is for the 
// sole purpose of programming logic devices manufactured by Altera and sold by 
// Altera or its authorized distributors.  Please refer to the applicable 
// agreement for further details.


// $Id: //acds/rel/13.0sp1/ip/merlin/altera_tristate_conduit_bridge/altera_tristate_conduit_bridge.sv.terp#1 $
// $Revision: #1 $
// $Date: 2013/03/07 $
// $Author: swbranch $

//Defined Terp Parameters


			    

`timescale 1 ns / 1 ns
  				      
module cpu_top_tristate_bridge (
     input  logic clk
    ,input  logic reset
    ,input  logic request
    ,output logic grant
    ,input  logic[ 0 :0 ] tcs_sram_write_n
    ,output  wire [ 0 :0 ] sram_write_n
    ,input  logic[ 1 :0 ] tcs_sram_byte_enable_n
    ,output  wire [ 1 :0 ] sram_byte_enable_n
    ,output logic[ 15 :0 ] tcs_tri_data_in
    ,input  logic[ 15 :0 ] tcs_tri_data
    ,input  logic tcs_tri_data_outen
    ,inout  wire [ 15 :0 ]  tri_data
    ,input  logic[ 0 :0 ] tcs_sram_read_n
    ,output  wire [ 0 :0 ] sram_read_n
    ,input  logic[ 0 :0 ] tcs_flash_read_n
    ,output  wire [ 0 :0 ] flash_read_n
    ,input  logic[ 0 :0 ] tcs_sram_cs_n
    ,output  wire [ 0 :0 ] sram_cs_n
    ,input  logic[ 24 :0 ] tcs_tri_address
    ,output  wire [ 24 :0 ] tri_address
    ,input  logic[ 0 :0 ] tcs_flash_cs_n
    ,output  wire [ 0 :0 ] flash_cs_n
    ,input  logic[ 0 :0 ] tcs_flash_write_n
    ,output  wire [ 0 :0 ] flash_write_n
		     
   );
   reg grant_reg;
   assign grant = grant_reg;
   
   always@(posedge clk) begin
      if(reset)
	grant_reg <= 0;
      else
	grant_reg <= request;      
   end
   


 // ** Output Pin sram_write_n 
 
    reg                       sram_write_nen_reg;     
  
    always@(posedge clk) begin
	 if( reset ) begin
	   sram_write_nen_reg <= 'b0;
	 end
	 else begin
	   sram_write_nen_reg <= 'b1;
	 end
     end		     
   
 
    reg [ 0 : 0 ] sram_write_n_reg;   

     always@(posedge clk) begin
	 sram_write_n_reg   <= tcs_sram_write_n[ 0 : 0 ];
      end
          
 
    assign 	sram_write_n[ 0 : 0 ] = sram_write_nen_reg ? sram_write_n_reg : 'z ;
        


 // ** Output Pin sram_byte_enable_n 
 
    reg                       sram_byte_enable_nen_reg;     
  
    always@(posedge clk) begin
	 if( reset ) begin
	   sram_byte_enable_nen_reg <= 'b0;
	 end
	 else begin
	   sram_byte_enable_nen_reg <= 'b1;
	 end
     end		     
   
 
    reg [ 1 : 0 ] sram_byte_enable_n_reg;   

     always@(posedge clk) begin
	 sram_byte_enable_n_reg   <= tcs_sram_byte_enable_n[ 1 : 0 ];
      end
          
 
    assign 	sram_byte_enable_n[ 1 : 0 ] = sram_byte_enable_nen_reg ? sram_byte_enable_n_reg : 'z ;
        


 // ** Bidirectional Pin tri_data 
   
    reg                       tri_data_outen_reg;
  
    always@(posedge clk) begin
	 tri_data_outen_reg <= tcs_tri_data_outen;
     end
  
  
    reg [ 15 : 0 ] tri_data_reg;   

     always@(posedge clk) begin
	 tri_data_reg   <= tcs_tri_data[ 15 : 0 ];
      end
         
  
    assign 	tri_data[ 15 : 0 ] = tri_data_outen_reg ? tri_data_reg : 'z ;
       
  
    reg [ 15 : 0 ] 	tri_data_in_reg;
								    
    always@(posedge clk) begin
	 tri_data_in_reg <= tri_data[ 15 : 0 ];
    end
    
  
    assign      tcs_tri_data_in[ 15 : 0 ] = tri_data_in_reg[ 15 : 0 ];
        


 // ** Output Pin sram_read_n 
 
    reg                       sram_read_nen_reg;     
  
    always@(posedge clk) begin
	 if( reset ) begin
	   sram_read_nen_reg <= 'b0;
	 end
	 else begin
	   sram_read_nen_reg <= 'b1;
	 end
     end		     
   
 
    reg [ 0 : 0 ] sram_read_n_reg;   

     always@(posedge clk) begin
	 sram_read_n_reg   <= tcs_sram_read_n[ 0 : 0 ];
      end
          
 
    assign 	sram_read_n[ 0 : 0 ] = sram_read_nen_reg ? sram_read_n_reg : 'z ;
        


 // ** Output Pin flash_read_n 
 
    reg                       flash_read_nen_reg;     
  
    always@(posedge clk) begin
	 if( reset ) begin
	   flash_read_nen_reg <= 'b0;
	 end
	 else begin
	   flash_read_nen_reg <= 'b1;
	 end
     end		     
   
 
    reg [ 0 : 0 ] flash_read_n_reg;   

     always@(posedge clk) begin
	 flash_read_n_reg   <= tcs_flash_read_n[ 0 : 0 ];
      end
          
 
    assign 	flash_read_n[ 0 : 0 ] = flash_read_nen_reg ? flash_read_n_reg : 'z ;
        


 // ** Output Pin sram_cs_n 
 
    reg                       sram_cs_nen_reg;     
  
    always@(posedge clk) begin
	 if( reset ) begin
	   sram_cs_nen_reg <= 'b0;
	 end
	 else begin
	   sram_cs_nen_reg <= 'b1;
	 end
     end		     
   
 
    reg [ 0 : 0 ] sram_cs_n_reg;   

     always@(posedge clk) begin
	 sram_cs_n_reg   <= tcs_sram_cs_n[ 0 : 0 ];
      end
          
 
    assign 	sram_cs_n[ 0 : 0 ] = sram_cs_nen_reg ? sram_cs_n_reg : 'z ;
        


 // ** Output Pin tri_address 
 
    reg                       tri_addressen_reg;     
  
    always@(posedge clk) begin
	 if( reset ) begin
	   tri_addressen_reg <= 'b0;
	 end
	 else begin
	   tri_addressen_reg <= 'b1;
	 end
     end		     
   
 
    reg [ 24 : 0 ] tri_address_reg;   

     always@(posedge clk) begin
	 tri_address_reg   <= tcs_tri_address[ 24 : 0 ];
      end
          
 
    assign 	tri_address[ 24 : 0 ] = tri_addressen_reg ? tri_address_reg : 'z ;
        


 // ** Output Pin flash_cs_n 
 
    reg                       flash_cs_nen_reg;     
  
    always@(posedge clk) begin
	 if( reset ) begin
	   flash_cs_nen_reg <= 'b0;
	 end
	 else begin
	   flash_cs_nen_reg <= 'b1;
	 end
     end		     
   
 
    reg [ 0 : 0 ] flash_cs_n_reg;   

     always@(posedge clk) begin
	 flash_cs_n_reg   <= tcs_flash_cs_n[ 0 : 0 ];
      end
          
 
    assign 	flash_cs_n[ 0 : 0 ] = flash_cs_nen_reg ? flash_cs_n_reg : 'z ;
        


 // ** Output Pin flash_write_n 
 
    reg                       flash_write_nen_reg;     
  
    always@(posedge clk) begin
	 if( reset ) begin
	   flash_write_nen_reg <= 'b0;
	 end
	 else begin
	   flash_write_nen_reg <= 'b1;
	 end
     end		     
   
 
    reg [ 0 : 0 ] flash_write_n_reg;   

     always@(posedge clk) begin
	 flash_write_n_reg   <= tcs_flash_write_n[ 0 : 0 ];
      end
          
 
    assign 	flash_write_n[ 0 : 0 ] = flash_write_nen_reg ? flash_write_n_reg : 'z ;
        

endmodule


